#include "strat.hpp"


hand::hand() {

  i_num = 0;
  needsupdate = 1;

}

hand::hand(int a) {

  i_num = 1;
  i_h[0] = a;
  needsupdate = 1;

}

hand::hand(int a, int b) {

  i_num = 2;
  i_h[0] = a;
  i_h[1] = b;
  needsupdate = 1;

}


void hand::addcard(int val) {

  i_h[i_num++] = val;
  needsupdate = 1;

}

void hand::changelast(int val) {

  i_h[i_num-1] = val;
  needsupdate = 1;

}

void hand::remlast() {

  i_num--;
  needsupdate = 1;

}


int hand::handval() {

  if (needsupdate) update();

  return i_handval;

}

int hand::issoft() {

  if (needsupdate) update();

  return i_issoft;

}

int hand::num() {

  return i_num;

}

int hand::single(int pos) {

  return i_h[pos];

}

inline void hand::update() {

  int numaces=0,sum=0,i;

  for(i=0; i<i_num; i++) {
    if (i_h[i] == 1) {
      numaces++;
      sum += 11;
    } else {
      sum += i_h[i];
    }
  }

  if (sum<=21 && numaces>0) i_issoft = 1;
  else i_issoft = 0;

  while (sum>21 && numaces>0) {
    numaces--;
    sum -= 10;
  }

  i_handval = sum;

  needsupdate = 0;

}
